import sys

TEMPLATE = """
def euler_XXX():
    return 0


if __name__ == "__main__":
    solution = euler_XXX()
    print("eXXX.py: " + str(solution))
    # assert(solution == 0)

"""


def main():
    try:
        e = sys.argv[1]
    except IndexError:
        print("Provide Euler problem number for which to create template.")
        return
    filename = "e" + e + ".py"
    with open(filename, "w") as f:
        s = TEMPLATE.replace("XXX", e)
        f.write(s)


if __name__ == "__main__":
    main()
